hdu 2084 数塔(dp)

Posted wz-archer

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了hdu 2084 数塔(dp)相关的知识,希望对你有一定的参考价值。

Problem Description

在讲述DP算法的时候,一个经典的例子就是数塔问题,它是这样描述的:
有如下所示的数塔,要求从顶层走到底层,若每一步只能走到相邻的结点,则经过的结点的数字之和最大是多少?
技术图片
已经告诉你了,这是个DP的题目,你能AC吗?

Input

输入数据首先包括一个整数C,表示测试实例的个数,每个测试实例的第一行是一个整数N(1 <= N <= 100),表示数塔的高度,接下来用N行数字表示数塔,其中第i行有个i个整数,且所有的整数均在区间[0,99]内。

Output

对于每个测试实例,输出可能得到的最大和,每个实例的输出占一行。

Sample Input

1
5
7
3 8
8 1 0
2 7 4 4
4 5 2 6 5

Sample Output

30
解:
如果采用贪心的思路,每一步我们都选取能走到得最大值,如下图:
技术图片

 

 红字部分就是贪心路径,发现和为28,显然不对。

当采取暴力搜索时,发现两个信息,1:当搜索到一个节点时在这个节点要解决的问题也是数塔问题,2,搜索过程中有大量重复子问题,如下图:

技术图片

 

 所以采取从下往上先求解子问题,记录子问题结果,再解决大问题的方法,这就是动态规划。

#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <cmath>
#include <map>

using namespace std;
typedef long long ll;

#define INF 0x7fffffff
const double inf=1e20;
const int maxn=100+10;
const int mod=1e9+7;

int a[maxn][maxn];

int main() {
    int t;
    scanf("%d",&t);
    while(t--){
        int n;
        scanf("%d",&n);
        for(int i=0;i<n;i++){
            for(int j=0;j<=i;j++){
                scanf("%d",&a[i][j]);
            }
        }
        //printf("...");
        for(int i=n-2;i>=0;i--){
            for(int j=0;j<=i;j++){
                a[i][j]+=max(a[i+1][j],a[i+1][j+1]);
            }
        }
        printf("%d
",a[0][0]);
    }
    return 0;
}

 

以上是关于hdu 2084 数塔(dp)的主要内容,如果未能解决你的问题,请参考以下文章

hdu 2084 数塔(dp)

HDU - 2084 数塔 (dp)

hdu2084 数塔 DP

HDU 2084 数塔

题解报告:hdu 2084 数塔

HDU 2084 数塔